import wx
import base64
from random import randrange
from md5 import md5
import string as ss

def encode(string,pwd=None):
    methods=[base64.b32encode,base64.b16encode,'uu','zip','hex']
    methods1={0:'x',1:'T',2:'?',3:'L',4:'!'}
    layers=[]
    
    while len(layers)<5:
        index=randrange(0,5)
        if (index in layers)==True:continue
        layers.append(index)
    
    for i in layers:
        if type(methods[i])!=type('str'):
            string=methods[i](string)
        else:string=string.encode(methods[i])
        if i==3 and pwd!=None:
            string+='pwd=>>>%s'%md5(pwd).hexdigest()
    
    result=base64.b64encode(string)
    n=int('1'+((len(str(len(result)))-2)*'0'))
    if n==1:n=5

    z=n
    while n<=len(result):
        letter=ss.ascii_uppercase[randrange(0,26)]
        result=result[:n-1]+letter+result[n-1:]
        n+=z
    
    layers2=[methods1[j] for j in layers]
    layers2=ss.join(layers2,'')

    result=result[:(len(result)/2)]+layers2+result[len(result)/2:]

    return result+'DN>'+str(z-14)

def decode(string,pwd=''):
    methods={'x':base64.b32decode,'T':base64.b16decode,'?':'uu','L':'zip','!':'hex'}
    string,n=string.split('DN>')
    n=int(n)+14
    layers=string[(len(string)-5)/2:((len(string)-5)/2)+5]
    string=string.replace(layers,'')
    
    z=n
    LW=list(string)
    while n<=len(string):
        LW[n-1]=''
        n+=z
    string=ss.join(LW,'')
    string=string.decode('base64')

    for i in layers[::-1]:
        if 'pwd=>>>' in string:
            t,password=string.split('pwd=>>>')
            if password!=md5(pwd).hexdigest():return 'PASS IS False'
        if type(methods[i])==type('str'):
            string=string.decode(methods[i])
        else:string=methods[i](string)
    return string

class EorD_Dialog(wx.Dialog):
    
    def __init__(self,parent,result,title='Encoding OR Decoding...'):
        wx.Dialog.__init__(self,parent,title=title)
        self.result=result
        self.SetSize((190,150))
        self.layout()
        
    def layout(self):
        self.SetBackgroundColour('#A24F6D')
        vbox=wx.BoxSizer(wx.VERTICAL)
        B1=wx.Button(self,label='Encoding File')
        B2=wx.Button(self,label='Decoding File')
        vbox.AddMany([(B1,0,wx.CENTER|wx.TOP,20),(B2,0,wx.CENTER|wx.TOP,20)])
        self.SetSizer(vbox)
        self.Bind(wx.EVT_BUTTON,self.close)
        self.Center()
        
    def close(self,e):
        self.result.E_or_D=e.GetEventObject().GetLabel()
        self.Destroy()

class Program():
    def __init__(self):
        self.App=wx.App()
        self.Frame=wx.Frame(None,title='Shia Encoder',style=wx.SYSTEM_MENU|wx.CAPTION |wx.CLOSE_BOX)
        self.layout()
        self.run()

    def layout(self):
        self.Frame.SetBackgroundColour('#A24F6D')
        vbox=wx.BoxSizer(wx.VERTICAL)
        hbox=wx.BoxSizer(wx.HORIZONTAL)
        SB=wx.StaticBitmap(self.Frame,bitmap=wx.Bitmap('key.jpg'))
        Button1=wx.Button(self.Frame,label='Encode_Decode File')
        Button2=wx.Button(self.Frame,label='Encode_Decode String')
        vbox.Add(SB,1,wx.CENTER)
        hbox.AddMany([(Button1,0,wx.RIGHT,20),(Button2,0)])
        vbox.Add(hbox,1,wx.EXPAND|wx.ALIGN_CENTER|wx.ALL,60)
        self.Frame.SetSizer(vbox)

        menubar=wx.MenuBar()
        menu=wx.Menu()
        item=wx.MenuItem(menu,1,'About\tCtrl+A')
        menu.AppendItem(item)
        menubar.Append(menu,'&Help')
        self.Frame.SetMenuBar(menubar)
        menu.Bind(wx.EVT_MENU,self.About,item)
        Button1.Bind(wx.EVT_BUTTON,self.File)
        Button2.Bind(wx.EVT_BUTTON,self.Text)
        self.Frame.Center()

    def Text(self,e):
        self.Frame.Hide()
        window=wx.Frame(self.Frame,title='Shia Encoder: Text Encode_Decode',style=wx.SYSTEM_MENU|wx.CAPTION|wx.CLOSE_BOX,size=(650,400))
        window.SetBackgroundColour('#A24F6D')
        vbox=wx.BoxSizer(wx.VERTICAL)
        hbox=wx.BoxSizer(wx.HORIZONTAL)
        self.CP=wx.CheckBox(window,label='Set or Write password')
        self.TP=wx.TextCtrl(window,size=(400, 23))
        self.TP.Enable(False)
        self.TN=wx.TextCtrl(window,style=wx.TE_MULTILINE)
        self.TE=wx.TextCtrl(window,style=wx.TE_MULTILINE)
        self.TN.Enable(False)
        self.TE.Enable(False)
        self.TN.SetValue('Normal Text')
        self.TE.SetValue('Encoded Text')
        hbox.AddMany([(self.TN,1,wx.ALL|wx.EXPAND,20),(self.TE,1,wx.ALL|wx.EXPAND,20)])
        hbox1=wx.BoxSizer(wx.HORIZONTAL)
        self.RBE=wx.RadioButton(window,label='Encoding')
        self.RBD=wx.RadioButton(window,label='Dicoding')
        hbox1.AddMany([(self.RBE,0,wx.RIGHT,460),(self.RBD)])
        CB=wx.Button(window,label='Convert')
        vbox.AddMany([(hbox1,0,wx.EXPAND|wx.LEFT|wx.TOP,20),(hbox,1,wx.EXPAND),(self.CP,0,wx.LEFT|wx.BOTTOM,10),(self.TP,0,wx.BOTTOM|wx.LEFT,10),(CB,0,wx.ALIGN_CENTER|wx.BOTTOM,20)])
        window.SetSizer(vbox)
        self.CP.Bind(wx.EVT_CHECKBOX,self.CPE)
        window.Bind(wx.EVT_CLOSE,self.close)
        window.Bind(wx.EVT_RADIOBUTTON,self.RB)
        window.Bind(wx.EVT_BUTTON,self.ConvertS)
        window.Show()

    def CPE(self,e):
        if self.CP.IsChecked():
            self.TP.Enable(True)
        else:
            self.TP.SetValue('')
            self.TP.Enable(False)

    def ConvertS(self,e):
        CP=self.CP.IsChecked()
        if self.RBE.GetValue():
            Text=self.TN.GetValue()
            if CP:
                result=encode(Text,self.TP.GetValue())
            elif CP==False:
                result=encode(Text)
            self.TE.Enable(True)
            self.TE.SetValue(result)
        if self.RBD.GetValue():
            EncodedText=self.TE.GetValue()
            if CP:
                result=decode(EncodedText,self.TP.GetValue())
                if result=='PASS IS False':
                    wx.MessageBox('The Password is incorrect\nPlease try again','Password',wx.OK|wx.ICON_ERROR)
                    return
            elif CP==False:
                result=decode(EncodedText)
            self.TN.Enable(True)
            self.TN.SetValue(result)

    def File(self,e):
        self.Frame.Hide()
        window=wx.Frame(None,title='Shia Encoder: File Decode_Encode',size=(650,400),style=wx.CAPTION|wx.CLOSE_BOX|wx.SYSTEM_MENU)
        window.SetBackgroundColour('#A24F6D')
        Dialog=EorD_Dialog(None,self)
        Dialog.ShowModal()
        if self.E_or_D=='Encoding File':
            self.FC1=wx.FilePickerCtrl(window)
            self.FC2=wx.FilePickerCtrl(window,style=wx.FLP_SAVE,wildcard='*.SE')
        elif self.E_or_D=='Decoding File':
            self.FC1=wx.FilePickerCtrl(window,wildcard='*.SE')
            self.FC2=wx.FilePickerCtrl(window,style=wx.FLP_SAVE)

        vbox=wx.BoxSizer(wx.VERTICAL)
        self.CP=wx.CheckBox(window,label='Set or Write password')
        self.CP.Bind(wx.EVT_CHECKBOX,self.CPE)
        self.TP=wx.TextCtrl(window,size=(400,23))
        self.TP.Enable(False)
        Button=wx.Button(window,label='Convert')
        Button.Bind(wx.EVT_BUTTON,self.ConvertFile)
        
        FGS=wx.FlexGridSizer(2,2,10,20)
        FGS.AddMany([(wx.StaticText(window,label='Target File:')),(self.FC1,0,wx.EXPAND),(wx.StaticText(window,label='Save result File At:')),(self.FC2,0,wx.EXPAND)])
        FGS.AddGrowableCol(1,1)
        vbox.Add(FGS,0,wx.EXPAND|wx.ALL,50)
        vbox.AddMany([(self.CP,0,wx.LEFT|wx.BOTTOM,20),(self.TP,0,wx.LEFT,20),(Button,0,wx.CENTER|wx.TOP,40)])
        
        window.SetSizer(vbox)
        window.Show()
        window.Bind(wx.EVT_CLOSE,self.close)

    def ConvertFile(self,e):
        File=open(self.FC1.GetPath(),'rb')
        
        if self.E_or_D=='Encoding File':
            Rfile=open(self.FC2.GetPath(),'wb')
            Format=ss.split(self.FC1.GetPath(),'.')[-1]
            if self.CP.IsChecked():
                result=encode(File.read(),self.TP.GetValue())
            elif self.CP.IsChecked()==False:
                result=encode(File.read())
            result+='FileFormat>>'+base64.b64encode(Format)
            Rfile.write(result)
            Rfile.close()
            File.close()
            wx.MessageBox('File Encoding was successfully','Finish',wx.OK)
            
        elif self.E_or_D=='Decoding File':
            result,Format=ss.split(File.read(),'FileFormat>>')
            Format=base64.b64decode(Format)
            if self.CP.IsChecked():
                result=decode(result,self.TP.GetValue())
            elif self.CP.IsChecked()==False:
                result=decode(result)
                if result=='PASS IS False':
                    wx.MessageBox('The Password is incorrect\nPlease try again','Password',wx.OK|wx.ICON_ERROR)
                    return
            Rfile=open(self.FC2.GetPath()+'.'+Format,'wb')
            Rfile.write(result)
            Rfile.close()
            File.close()
            wx.MessageBox('File Decoding was successfully','Finish',wx.OK)

    def close(self,e):
        self.Frame.Show()
        e.Skip()

    def RB(self,e):
        self.TN.SetValue('')
        self.TE.SetValue('')
        if self.RBE.GetValue():
            self.TN.Enable(True)
            self.TE.Enable(False)
        elif self.RBD.GetValue():
            self.TN.Enable(False)
            self.TE.Enable(True)
            
    def About(self,e):
        info=wx.AboutDialogInfo()
        info.SetIcon(wx.Icon('Shia.jpg'))
        info.SetName('Shia Encoder')
        info.SetVersion('1.0')
        info.SetCopyright('(C) 2014 Ehsan Abedian')
        info.SetLicense('''GNU General Public License(GPL),version 3
Read full License on:
http://www.gnu.org/licenses/gpl-3.0.html''')
        
        info.AddDeveloper('Ehsan Abedian')
        info.SetDescription('''This Program can Encode and Decode
Files and Strings.
Everyone can Use It and improve this program.

Call me on:

programmer_2014i@yahoo.com
abedian2014@gmail.com
''')
        
        wx.AboutBox(info)

    def run(self):
        self.Frame.Show()
        self.App.MainLoop()

Program()
